<template>
	<zj-tab-page ref="tabPage" :defaultActives="[{ key: 'list', label: $route.meta.title+'-列表', essential: true }]">
		<template slot-scope="{activeKey, data}">
			<template-page v-if="activeKey == 'list'" ref="pageRef" :get-list="getList" :table-attributes="tableAttributes" :table-events="tableEvents"
			  :options-evens-group="optionsEvensGroup" :moreParameters="moreParameters" :column-parsing="columnParsing"
			  :operation="operation()" :exportList="exportList" :operationColumnWidth="160">
			</template-page>
			<div v-if="~['add', 'edit'].indexOf(activeKey)">
				<zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
				  <zj-form-module title="" label-width="100px" :showPackUp="false"
				    :form-data="formData" :form-items="formItems">
				  </zj-form-module>
				</zj-form-container>
				<div slot="footer" class="dialog-footer">
				  <el-button size="mini" @click="data.removeTab()">取 消</el-button>
				  <el-button size="mini" @click="formConfirm(data.removeTab)" type="primary">确 定</el-button>
				</div>
			</div>
		</template>
	</zj-tab-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import {
  goodsNewsCategoryListPageV2,
  goodsNewsCategoryPageExport,
  addNewclassify,
  getNewclassifyDetail,
  editNewclassifyDetail,
  changeNewclassify,
  deleteNewclassify
} from "@/api/goods";
import operation_mixin from '@/components/template/operation_mixin.js'
export default {
  components: { TemplatePage },
  mixins: [import_mixin,operation_mixin],
  data() {
    return {
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ["新增", "编辑"],
      formDialog: false,
      formData: {
        mainTitle: '',
        subTitle: '',
        type: '',
        sortNum: '',
      },
			formType: 'add',
			formVisible: false,
    }
  },
  computed: {
	// 事件组合
	optionsEvensGroup() {
		return [
			[
				[
					this.optionsEvensAuth("add", {
						click: () => {
							this.openForm('add')
						}
					})
				]
			]
		]
	},
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [{
        md: 6,
        isShow: true,
        name: 'el-input',
        attributes: { placeholder: '请输入' },
        formItemAttributes: {
          label: '主标题',
          prop: 'mainTitle',
          rules: [...required]
        }
      }, {
        md: 6,
        isShow: true,
        name: 'el-input',
        attributes: { placeholder: '请输入' },
        formItemAttributes: {
          label: '副标题',
          prop: 'subTitle',
          rules: [...required]
        }
      },
      {
        md: 6,
        isShow: true,
        name: 'el-radio',
        options: [
          { label: "普通商品", value: 1 },
          { label: "套购商品", value: 2 },
        ],
        attributes: { filterable: true, placeholder: '请选择', disabled: this.formData.flag === 'START' || this.formDialogType == 2 },
        formItemAttributes: {
          label: '商品类别',
          prop: 'type',
          rules: [...required]
        }
      }, {
        md: 6,
        isShow: true,
        name: 'el-input',
        attributes: { placeholder: '请输入' },
        formItemAttributes: {
          label: '排序',
          prop: 'sortNum',
          rules: []
        }
      }]
    }
  },
  methods: {
    // 列表请求函数
    getList: goodsNewsCategoryListPageV2,
    // 列表导出函数
    exportList: goodsNewsCategoryPageExport,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
	// 表格操作列
	operation() {
		return this.operationBtn({
			disposition: {
				btnType: 'text',
				click: ({ row, index, column }) => {
					// this.$router.push({
					// 	name: "newclassify_set",
					// 	query: {
					// 		item: row
					// 	},
					// });
					this.$router.push({
						name: 'newclassify_set',
						params: {
							pageName: row.goodsNewsCategoryId,
							pageType: '-',
							pageCode: JSON.stringify(row)
						},
					})
				}
			},
			edit: {  
				btnType: 'text',
				click: ({ row, index, column }) => {
					this.openForm('edit',row.goodsNewsCategoryId)
				}
			},
			del: {
				btnType: 'text',
				prompt: '确定删除吗？',
				click: ({ row, index, column }) => {
					deleteNewclassify({ goodsNewsCategoryId: row.goodsNewsCategoryId }).then(() => {
						this.$message({ type: 'success', message: '删除成功!' })
						this.$refs.pageRef.refreshList()
					})
				}
			},
			status: {
				btnType: 'text',
				name: ({ row, index, column }) => {
					return Number(row.status) ? "关闭" : "开启"
				},
				prompt:  ({ row, index, column }) => {
					return `是否确定${Number(row.status) ? "关闭" : "开启"}？`
				},
				click: ({ row, index, column }) => {
					changeNewclassify({
						goodsNewsCategoryId: row.goodsNewsCategoryId,
						status: Number(row.status) ? 0 : 1,
					}).then(res => {
						this.$message({ type: 'success', message: `${Number(row.status) ? "关闭" : "开启"}成功!` })
						this.$refs.pageRef.refreshList()
					})
				}
			},
		})
	},
    openForm(type, newsCategoryId) {
      this.$refs.tabPage.addTab({
      	// 对应显示的模块
      	activeKey: type,
      	// 唯一标识
      	key: type,
      	// 页签名称
      	label: ({ edit: "编辑", add: "新增" })[type],
      	// 打开时事件
      	triggerEvent: () => {
      		this.formCancel()
      		this.$nextTick(()=>{
      			this.formType = type
      			this.formVisible = true
      			if (type == 'add') {
      				this.formDialogType = 0
      			} else if(type == 'edit'){
      				this.formDialogType = 1
      				getNewclassifyDetail({ newsCategoryId  }).then(res => {
      					Object.assign(this.formData, res.data)
      				})
      			}
      		})
      	},
      	// 关闭时事件
      	closeEvent: () => {
      	
      	}
      })
    },
    formCancel() {
      this.formVisible = false
      this.$refs?.formRef?.resetFields()
      this.$data.formData = this.$options.data().formData
    },
    formConfirm(cancel) {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          ([addNewclassify, editNewclassifyDetail][this.formDialogType])(this.formData).then(res => {
            this.$message({ type: 'success', message: `${this.formDialogTitles[this.formDialogType]}成功!` })
            cancel('list')
            this.$refs.pageRef.refreshList()
          })
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped></style>
